Lua_CloundBuyResultWindow = class("Lua_CloundBuyResultWindow", Lua_FullSizeWindow);
function Lua_CloundBuyResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CloundBuyResultWindow";
	self.skinName = "CloundBuyResultWindow_skin";
	self.showTitle = false;
	self.showMoney = false;
	self.showClose = false;
	self.isClickClose = false;
end

function Lua_CloundBuyResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.toolImg = Lua_ToolImage.new(self.content);
	self.toolImg:setDepth(5);
	self.toolImg:setLocation(0, 75, 0);

	self.subBtn:addClickFuntion(self, self.onBtnCloseClick);

	self.startTime = getTime();
	self:addTimer("Lua_CloundBuyResultWindow", 0.5, self, self.onEnterFrame);
end

function Lua_CloundBuyResultWindow:showWin(data)
	local tvo = Lua_ToolVo.createToolVo(data.item.id, 1, 1);
	tvo:fromServer(data.item);
	self.toolImg.data = tvo;
	self.itemName.text = tvo.colorName;

	local str = "";
	for i,v in ipairs(data.role_list) do
		str = str..v.role_name;
		if i ~= #data.role_list then
			str = str..", ";
		end
	end
	self.rsName.text = str;
	self:onEnterFrame();
end

function Lua_CloundBuyResultWindow:onEnterFrame()
	local pt = getTime() - self.startTime;
	local lt = 10 - pt;
	if lt > 0 then
		lt = math.floor(lt);
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(120935), tostring(lt));
	else
		self:hide();
	end
end