-- 限时云购-1028
Lua_CloundBuyWindow = class("Lua_CloundBuyWindow", Lua_Window);
function Lua_CloundBuyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CloundBuyWindow";
	self.skinName = "CloundBuyWindow_skin";
end

function Lua_CloundBuyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.leftTimeTxt.text = "";
	self.buyTxt.text = "";
	self.valueTxt.text = "";

	self.bigImg = Lua_ToolImage.new(self.content);
	self.bigImg:setLocation(-186, 116, 0);
	self.bigImg:setScale(1.2,1.2);
	self.bigImg:setDepth(5);

	self.rewardItem = Lua_RewardDragItem.new(self.content, 580, 100);
	self.rewardItem.pivot = 2;
	self.rewardItem:setDepth(5);
	self.rewardItem:setLocation(-166, -74, 0);
	self.rewardItem:setScale(0.9, 0.9);

	self.textArea = Lua_TextArea.new(self.content, 325, 325);
	self.textArea.insideItem.label.fontSize = 22;
	self.textArea.insideItem.label.spacingY = 8;
	self.textArea:setLocation(153, 195, 0);

	self.buyBg:addClickFuntion(self, self.onBuyClick);
	self.buyBg10:addClickFuntion(self, self.onBuy10Click);
	self.shuomingSp:addClickFuntion(self, self.onWanFaClick);
	self.lishiSp:addClickFuntion(self, self.onLiShiClick);

	self:addTimer("Lua_CloundBuyWindow", 0.3, self, self.onEnterFrame);

	self:addLuaEvent("CLOUND_BUY_UPDATE", self, self.updateCloundBuyInfo);
	self:addLuaEvent("CLOUND_BUY_LIST", self, self.onBuyListUpdate);
	sendMsg(10105201);
	sendMsg(10105202);
	sendMsg(10105205);
end

function Lua_CloundBuyWindow:updateCloundBuyInfo(msg)
	self.infoMsg = msg;
	self.titleTxt.text = LanUtil.formateStr(LanUtil.getValue(124225), tostring(msg.cycle), tostring(msg.total_cycle));
	
	local tvo = Lua_ToolVo.createToolVo(self.infoMsg.big_reward.id, 1, 1);
	tvo:fromServer(self.infoMsg.big_reward);
	self.bigImg.data = tvo;

	local rewardArr = Array();
	for i,v in ipairs(msg.normal_item_list) do
		tvo = Lua_ToolVo.createToolVo(v.id, 1, 0);
		tvo:fromServer(v);
		rewardArr:add(tvo);
	end
	self.rewardItem:setRewardByArray(rewardArr);

	self.buyTxt.text = tostring(msg.price);
	self.buyTxt10.text = tostring(msg.ten_price);

	local h = math.floor(self.infoMsg.nolimit_tick / 3600);
	local m = (self.infoMsg.nolimit_tick - h * 3600) / 60;
	local mstr = tostring(m);
	if string.len(mstr) == 1 then
		mstr = "0"..mstr;
	end

	local t = tonumber(tostring(GlobalVar.cur_tick));
	local ot = os.date("*t", t)
	local nowDayTime = ot.hour * 3600 + ot.min * 60 + ot.sec;
	local limitStr = tostring(self.infoMsg.total_buy_times);
	if nowDayTime >= self.infoMsg.nolimit_tick then
		limitStr = LanUtil.getValue(121215);
	end

	self.infoTxt.text = LanUtil.formateStr(LanUtil.getValue(124218), self.infoMsg.buy_times.."/"..limitStr, 
		h..":"..mstr, tostring(self.infoMsg.left_stock_amount), tostring(self.infoMsg.max_stock_amount));

	self.valueTxt.text = LanUtil.formateStr(LanUtil.getValue(124219), tostring(msg.big_reward_price));

	if msg.cycle_state ~= 1 then
		if msg.cycle_state == 0 then
			self.endTxt.text = LanUtil.getValue(124224);
		else
			self.endTxt.text = LanUtil.getValue(124223);
		end
		self.endTxt:setEnable(true);
		self.buyBg:setEnable(false);
		self.buyTxt:setEnable(false);
		self.moneyIcon2:setEnable(false);
		self.bTxt:setEnable(false);

		self.buyBg10:setEnable(false);
		self.buyTxt10:setEnable(false);
		self.moneyIcon10:setEnable(false);
		self.bTxt10:setEnable(false);
	else
		self.endTxt:setEnable(false);
		self.buyBg:setEnable(true);
		self.buyTxt:setEnable(true);
		self.moneyIcon2:setEnable(true);
		self.bTxt:setEnable(true);

		self.buyBg10:setEnable(true);
		self.buyTxt10:setEnable(true);
		self.moneyIcon10:setEnable(true);
		self.bTxt10:setEnable(true);
	end

	self.startTime = getTime();
	self.leftTime = msg.left_sec;
	self:onEnterFrame();
end

function Lua_CloundBuyWindow:onBuyListUpdate(msg)
	local len = #msg.role_list;
	local langValue;
	local str = "";
	for i = 1, len do
		if msg.role_list[i].type == 1 then
			if msg.role_list[i].count ~= nil and msg.role_list[i].count > 1 then
				langValue = 124226;
			else
				langValue = 124220;
			end
		else
			langValue = 124222;
		end
		
		str = str..LanUtil.formateStr(LanUtil.getValue(langValue), msg.role_list[i].role_name, tostring(msg.role_list[i].count));
		if i < len then
			str = str.."\n";
		end
	end
	self.textArea:setText(str);
end

function Lua_CloundBuyWindow:onEnterFrame()
	if self.startTime ~= nil then
		local sec = self.leftTime - (getTime() - self.startTime);
		if sec <= 0 then
			sec = 0;
		end
		self.leftTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(124217), TimeTransform.getInstance():transSeconds6(sec, true, true));
	end
end

function Lua_CloundBuyWindow:onBuy10Click()
	DataCenter.moneyData:showReconfigPanel(tonumber(self.infoMsg.ten_price), self, self._onBuy10Click);
end

function Lua_CloundBuyWindow:_onBuy10Click()
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.infoMsg.ten_price, true, true) == false then
		return;
	end
	if self.lastTime ~= nil and getTime() - self.lastTime < 0.5 then
		return;
	end

	self.lastTime = getTime();
	local cmd = ProtoPublic_pb.Proto10105204();
	cmd.times = 10;
	sendMsg(10105204, cmd);
end

function Lua_CloundBuyWindow:onBuyClick()
	DataCenter.moneyData:showReconfigPanel(tonumber(self.infoMsg.price), self, self._onBuyClick);
end

function Lua_CloundBuyWindow:_onBuyClick()
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.infoMsg.price, true, true) == false then
		return;
	end
	if self.lastTime ~= nil and getTime() - self.lastTime < 0.5 then
		return;
	end
	self.lastTime = getTime();

	local cmd = ProtoPublic_pb.Proto10105204();
	cmd.times = 1;
	sendMsg(10105204, cmd);
end

function Lua_CloundBuyWindow:onWanFaClick()
	if self.infoMsg == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, self.infoMsg.act_content);
end

function Lua_CloundBuyWindow:onLiShiClick()
	Lua_WindowUtil.openWin("Lua_CloundBuyHistoryWindow", WinParam.ACTION_AUTO);
end

function Lua_CloundBuyWindow:dispose()
	if self.bigImg ~= nil then
		self.bigImg:dispose();
		self.bigImg = nil;
	end
	if self.textArea ~= nil then
		self.textArea:dispose();
		self.textArea = nil;
	end
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end

	sendMsg(10105206);
	self:superCall("dispose");
end